#include "stdafx.h"
#include "constants.h"
#include "char.h"
#include "config.h"
#include "desc_client.h"
#include "desc_manager.h"
#include "unique_item.h"
#include "utils.h"
#include "packet.h"
#include "log.h"
#include "quest.h"
#include "questmanager.h"
#include "db.h"

#include "../../common/service.h" //Or another file with your defs. It is needed to be included here.


#ifdef ENABLE_STATIC_BROADCAST

#include "static_broadcast.h"
CStaticBroadcast::CStaticBroadcast()
{
}

struct SendDataFunc
{
	void operator () (LPDESC d)
	{
		if (d->GetCharacter())
		{
			d->GetCharacter()->ChatPacket(CHAT_TYPE_COMMAND, "BINARY_Update_StBroadcast %s", CStaticBroadcastManager::instance().GetText());
		}
	}
};

struct SendRemoveBroadcastFunc
{
	void operator () (LPDESC d)
	{
		if (d->GetCharacter())
		{
			d->GetCharacter()->ChatPacket(CHAT_TYPE_COMMAND, "BINARY_Update_StBroadcast rm");
		}
	}
};

void CStaticBroadcast::SendDataToClients()
{
	const DESC_MANAGER::DESC_SET & c_set_desc = DESC_MANAGER::instance().GetClientSet();
	std::for_each(c_set_desc.begin(), c_set_desc.end(), SendDataFunc());
}

void CStaticBroadcast::ShowPreview(LPCHARACTER ch)
{
	if(ch == NULL || ch->GetDesc() == NULL)
		return;
	
	ch->ChatPacket(CHAT_TYPE_COMMAND, "BINARY_Update_StBroadcast %s", CStaticBroadcastManager::instance().GetText());
	return;
}

CStaticBroadcastManager::CStaticBroadcastManager()
{
}

void CStaticBroadcastManager::SetText(const char* sText)
{
	char szQuery[2048];
	snprintf(szQuery, sizeof(szQuery), "UPDATE player.broadcast_data SET text = replace(\"%s\",' ','//')", sText);
	DBManager::instance().DirectQuery(szQuery);
	return;
}

void CStaticBroadcastManager::SetStatus(int iStatus)
{
	if(iStatus < 0 || iStatus > 1)
	{
		sys_err("Static Broadcast > Unknown error.");
		return;
	}
	
	char szQuery[2048];	
	snprintf(szQuery, sizeof(szQuery), "UPDATE player.broadcast_data SET status = %i", iStatus);
	DBManager::instance().DirectQuery(szQuery);
	
	switch (iStatus)
	{
		case 0:
		{
			const DESC_MANAGER::DESC_SET & c_set_desc = DESC_MANAGER::instance().GetClientSet();
			std::for_each(c_set_desc.begin(), c_set_desc.end(), SendRemoveBroadcastFunc());
			break;
		}
		case 1:
		{
			CStaticBroadcast::instance().SendDataToClients();
			break;
		}
		default:
			sys_err("Static Broadcast > Unknown error.");
	}
	return;
}

const char* CStaticBroadcastManager::GetText()
{
	SQLMsg * pMsg = DBManager::instance().DirectQuery("SELECT text FROM player.broadcast_data");
		
	if (pMsg->Get()->uiNumRows > 0)
	{
		MYSQL_ROW row = mysql_fetch_row(pMsg->Get()->pSQLResult);
		return row[0];
		delete pMsg;
	}
	
	return "null";
}

int CStaticBroadcastManager::GetStatus()
{
	int iStatus = -1;
	
	SQLMsg * pMsg = DBManager::instance().DirectQuery("SELECT status FROM player.broadcast_data");
		
	if (pMsg->Get()->uiNumRows > 0)
	{
		MYSQL_ROW row = mysql_fetch_row(pMsg->Get()->pSQLResult);
		str_to_number(iStatus, row[0]);
		return iStatus;
		delete pMsg;
	}
	
	return iStatus;
}
#endif

